#include "syncscheduler_sfy.hpp"
#include "DataInputWindow.hpp"
#include "MainWindow.hpp"
#include "syncscheduler_sfy.brh"
#include "SoftMenuID.hpp"

// RXgN^
DataInputWindow::DataInputWindow(Void)static_throws
{
    static SFXEventRange::AtomRecConst range[] = {
        {SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END},
        {SFEVT_RESPONDER_SOFTKEY, SFEVT_RESPONDER_SOFTKEY, AVK_SOFT1, AVK_SOFT2}
    };
    SFYHandler::RuleRec rule[lengthof(range)];

    if (static_try()) {
        rule[0].spp = XANDLER_FUNCTION(OnKey);      // L[nh
        rule[0].reference = this;
        rule[1].spp = XANDLER_FUNCTION(OnSoftKey);  // \tgL[nh
        rule[1].reference = this;
        // nh̓o^
        static_throw(RegisterHandler(atomic_cast(range), rule, lengthof(range)));
        if (static_try()) {
            // \tgL[j[̐ݒ
            static_throw(SetSoftMenu());
            if (static_try()) {
                // _CAOwp[̎擾
                if ((_dialoger = syncscheduler_sfy::GetDialoger()) != null) {
                    _vcal = null;
                }
                else {
                    static_throw(SFERR_FAILED);
                }
            }
        }
    }
}

// fXgN^
DataInputWindow::~DataInputWindow(Void)
{
}

// CX^X̍쐬
DataInputWindowSmp DataInputWindow::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<DataInputWindow>(Factory(::new DataInputWindow(), exception));
}

// X|_̍쐬
SFCError DataInputWindow::Make(SFXDateConstRef date, VCalendarItemPtr vcal)
{
    SFCError error;

    _vcal = vcal;
    if (_vcal != null) {
        _start.date = _vcal->GetStartDate();
        _end.date = _vcal->GetEndDate();
    }
    else {
        _start.date = date;
        _end.date = date;
    }
    if ((error = CreateStartRow()) == SFERR_NO_ERROR) {
        if ((error = CreateEndRow()) == SFERR_NO_ERROR) {
            if ((error = CreatePlan()) == SFERR_NO_ERROR) {
                Locate();
                _start.editHour->SetStateFocus(true);
            }
        }
    }
    return error;
}

// \tgL[j[̐ݒ
SFCError DataInputWindow::SetSoftMenu(Void)
{
    SFZSoftKeyControlSmp softkey;
    SFCError error(SFERR_NO_ERROR);

    if ((softkey = syncscheduler_sfy::GetSoftKey()) != null) {
        if (!softkey->ContainsMenuKey(SOFTMENU_INPUT)) {
            if ((error = softkey->CreateMenu(SOFTMENU_INPUT)) == SFERR_NO_ERROR) {
                UInt32 key[] = {IDS_SOFTKEY_SELECT, IDS_SOFTKEY_RETURN, IDS_SOFTKEY_REGISTER};
                error = softkey->SetTextKey(SOFTMENU_INPUT, key, lengthof(key));
            }
        }
        if (error == SFERR_NO_ERROR) {
           softkey->Bind(this, SOFTMENU_INPUT);
        }
    }
    return error;
}

// Jn͊֘ÃX|_쐬
SFCError DataInputWindow::CreateStartRow(Void)
{
    return CreateRowImpl(_start, syncscheduler_sfy::LoadString(IDS_DATE_START));
}

// I͊֘ÃX|_쐬
SFCError DataInputWindow::CreateEndRow(Void)
{
    return CreateRowImpl(_end, syncscheduler_sfy::LoadString(IDS_DATE_END));
}

// ͊֘ÃX|_쐬 ()
SFCError DataInputWindow::CreateRowImpl(DateInputRowRecRef rec, SFXWideStringConstRef text)
{
    SFCError error;

    // tx̍쐬
    if ((rec.labelDate = SFZSingleTextLabelControl::NewInstance(&error)) != null) {
        if ((error = rec.labelDate->SetParent(GetThis())) == SFERR_NO_ERROR) {
            if ((error = rec.labelDate->SetText(text)) == SFERR_NO_ERROR) {
                rec.labelDate->SetHorizontalAlign(SFZSingleTextLabelControl::HORIZONTAL_LEFT);
                rec.labelDate->SetState(true, true, false, false);
            }
        }
    }
    // ̓eGfBbg{bNX̐
    if (error == SFERR_NO_ERROR) {
        if ((rec.editHour = SFZSingleEditBoxControl::NewInstance(&error)) != null) {
            if ((error = rec.editHour->SetParent(GetThis())) == SFERR_NO_ERROR) {
                error = rec.editHour->RegisterHandler(
                    SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                    XANDLER_INTERNAL(OnEditHour)
                );
                if (error == SFERR_NO_ERROR) {
                    if ((error = rec.editHour->SetText(SFXAnsiString::Format("%02d", rec.date.GetHour()))) == SFERR_NO_ERROR) {
                        rec.editHour->SetInputMode(AEE_TM_NUMBERS);
                        rec.editHour->SetHorizontalAlign(SFZSingleEditBoxControl::HORIZONTAL_RIGHT);
                        rec.editHour->SetMaximumLength(2);
                        rec.editHour->SetState(true, true, true, false);
                    }
                }
            }
        }
    }
    // x̐
    if (error == SFERR_NO_ERROR) {
        if ((rec.labelHour = SFZSingleTextLabelControl::NewInstance(&error)) != null) {
            if ((error = rec.labelHour->SetParent(GetThis())) == SFERR_NO_ERROR) {
                if ((error = rec.labelHour->SetText(syncscheduler_sfy::LoadString(IDS_HOUR))) == SFERR_NO_ERROR) {
                    rec.labelHour->SetHorizontalAlign(SFZSingleTextLabelControl::HORIZONTAL_LEFT);
                    rec.labelHour->SetState(true, true, false, false);
                }
            }
        }
    }
    // GfBbg{bNX̐
    if (error == SFERR_NO_ERROR) {
        if ((rec.editMin = SFZSingleEditBoxControl::NewInstance(&error)) != null) {
            if ((error = rec.editMin->SetParent(GetThis())) == SFERR_NO_ERROR) {
                error = rec.editMin->RegisterHandler(
                    SFXEventRange(SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END),
                    XANDLER_INTERNAL(OnEditMinute)
                );
                if (error == SFERR_NO_ERROR) {
                    if ((error = rec.editMin->SetText(SFXAnsiString::Format("%02d", rec.date.GetMinute()))) == SFERR_NO_ERROR) {
                        rec.editMin->SetInputMode(AEE_TM_NUMBERS);
                        rec.editMin->SetHorizontalAlign(SFZSingleEditBoxControl::HORIZONTAL_RIGHT);
                        rec.editMin->SetMaximumLength(2);
                        rec.editMin->SetState(true, true, true, false);
                    }
                }
            }
        }
    }
    // x̐
    if (error == SFERR_NO_ERROR) {
        if ((rec.labelMin = SFZSingleTextLabelControl::NewInstance(&error)) != null) {
            if ((error = rec.labelMin->SetParent(GetThis())) == SFERR_NO_ERROR) {
                if ((error = rec.labelMin->SetText(syncscheduler_sfy::LoadString(IDS_MINUTE))) == SFERR_NO_ERROR) {
                    rec.labelMin->SetHorizontalAlign(SFZSingleTextLabelControl::HORIZONTAL_LEFT);
                    rec.labelMin->SetState(true, true, false, false);
                }
            }
        }
    }
    return error;
}

// \֘AX|_̐
SFCError DataInputWindow::CreatePlan(Void)
{
    SFCError error;

    // \胉x̍쐬
    if ((_labelPlan = SFZSingleTextLabelControl::NewInstance(&error)) != null) {
        if ((error = _labelPlan->SetParent(GetThis())) == SFERR_NO_ERROR) {
            if ((error = _labelPlan->SetText(syncscheduler_sfy::LoadString(IDS_SCHEDULE_DETAIL))) == SFERR_NO_ERROR) {
                _labelPlan->SetHorizontalAlign(SFZSingleTextLabelControl::HORIZONTAL_LEFT);
                _labelPlan->SetState(true, true, false, false);
            }
        }
    }
    // \GfBbg{bNX̍쐬
    if ((_editPlan = SFZMultipleEditBoxControl::NewInstance(&error)) != null) {
        if ((error = _editPlan->SetParent(GetThis())) == SFERR_NO_ERROR) {
            if (_vcal != null) {
                error = _editPlan->SetText(_vcal->GetSummary());
            }
            if (error == SFERR_NO_ERROR) {
                _editPlan->SetHorizontalAlign(SFZMultipleEditBoxControl::HORIZONTAL_LEFT);
                _editPlan->SetVerticalAlign(SFZMultipleEditBoxControl::VERTICAL_TOP);
                _editPlan->SetState(true, true, true, false);
                _editPlan->SetMaximumLength(255);
            }
        }
    }
    return error;
}

// ͓e`FbN
SFCError DataInputWindow::CheckContents(Void)
{
    SInt32 startHour = _start.editHour->GetText().AsSInt32();
    SInt32 startMin = _start.editMin->GetText().AsSInt32();
    SInt32 endHour = _end.editHour->GetText().AsSInt32();
    SInt32 endMin = _end.editMin->GetText().AsSInt32();
    SFCError error(SFERR_NO_ERROR);

    if (endHour < startHour) {
        error = SFERR_FAILED;
        _end.editHour->SetStateFocus(true);
    }
    else if (endHour == startHour && endMin < startMin) {
        error = SFERR_FAILED;
        _end.editMin->SetStateFocus(true);
    }
    if (error != SFERR_NO_ERROR) {
        _dialoger->SetTitle(Dialoger::ERROR);
        _dialoger->SetMessageText(syncscheduler_sfy::LoadString(IDS_END_DATE_ERROR));
        _dialoger->SetButtonState(Dialoger::OK);
        _dialoger->Execute();
    }
    return error;
}

// X|_̔zu
Void DataInputWindow::Locate(Void)
{
    SFXRectangle temp(GetLocalBound());
    SInt16  W, H, w1, w2, w3, h, x, y;

    x = MARGIN_X;
    y = MARGIN_Y;
    W = temp.GetWidth() - 2 * MARGIN_X;
    H = temp.GetHeight() - 2 * MARGIN_Y;
    h = SFXGraphics::GetInstance()->GetFontHeight() + 4;
    w1 = _start.labelDate->GetSuitableBound().GetWidth();
    {
        SFXWideString escape(_start.editHour->GetText());
        _start.editHour->SetText("  ");
        w2 = _start.editHour->GetSuitableBound().GetWidth();
        _start.editHour->SetText(escape);
    }
    w3 = _start.labelHour->GetSuitableBound().GetWidth();
    _start.labelDate->SetRealBound(SFXRectangle(x, y, w1, h));
    x += w1;
    _start.editHour->SetRealBound(SFXRectangle(x, y, w2, h));
    x += w2;
    _start.labelHour->SetRealBound(SFXRectangle(x, y, w3, h));
    x += w3;
    _start.editMin->SetRealBound(SFXRectangle(x, y, w2, h));
    x += w2;
    _start.labelMin->SetRealBound(SFXRectangle(x, y, w3, h));
    x = MARGIN_X;
    y += h;
    _end.labelDate->SetRealBound(SFXRectangle(x, y, w1, h));
    x += w1;
    _end.editHour->SetRealBound(SFXRectangle(x, y, w2, h));
    x += w2;
    _end.labelHour->SetRealBound(SFXRectangle(x, y, w3, h));
    x += w3;
    _end.editMin->SetRealBound(SFXRectangle(x, y, w2, h));
    x += w2;
    _end.labelMin->SetRealBound(SFXRectangle(x, y, w3, h));
    x = MARGIN_X;
    y += h;
    _labelPlan->SetRealBound(SFXRectangle(x, y, W, h));
    y += h;
    _editPlan->SetRealBound(SFXRectangle(x, y, W, H + MARGIN_Y - y));
    return;
}

// \ۑ
Void DataInputWindow::Save(Void)
{
    SInt16 startHour = static_cast<SInt16>(_start.editHour->GetText().AsSInt32());
    SInt16 startMin = static_cast<SInt16>(_start.editMin->GetText().AsSInt32());
    SInt16 endHour = static_cast<SInt16>(_end.editHour->GetText().AsSInt32());
    SInt16 endMin = static_cast<SInt16>(_end.editMin->GetText().AsSInt32());

    _start.date.SetTime(startHour, startMin, 0);
    _end.date.SetTime(endHour, endMin, 0);
    if (_vcal == null) {
        _vcal = ::new VCalendarItem;
        _vcal->SetStartDate(_start.date);
        _vcal->SetEndDate(_end.date);
        _vcal->SetLastModifiedDate(SFXDate::CurrentDate());
        _vcal->SetSummary(_editPlan->GetText());
        if (_vcal != null) {
            syncscheduler_sfy::GetVCalCollection()->InsertLast(_vcal);
        }
    }
    else {
        _vcal->SetStartDate(_start.date);
        _vcal->SetEndDate(_end.date);
        _vcal->SetLastModifiedDate(SFXDate::CurrentDate());
        _vcal->SetSummary(_editPlan->GetText());
        syncscheduler_sfy::GetVCalCollection()->Update(_vcal);
    }
    syncscheduler_sfy::GetVCalCollection()->Save();
    return;
}

// ẽt[ƃEBhEI
Void DataInputWindow::TerminateParentFrame(Void)
{
    SFYResponderSmp parent(GetParent());

    if (parent != null) {
        parent->Terminate();
    }
    return;
}

// L[nh
XANDLER_IMPLEMENT_BOOLEVENT(DataInputWindow, OnKey, invoker, event)
{
    Bool result(false);

    unused(invoker);
    switch (event.GetP16()) {
        case AVK_CLR:
            TerminateParentFrame();
            break;
    }
    return result;
}

// \tgL[nh
XANDLER_IMPLEMENT_VOIDEVENT(DataInputWindow, OnSoftKey, invoker, event)
{
    unused(invoker);
    switch (event.GetP16()) {
        case AVK_SOFT1:
            TerminateParentFrame();
            break;
        case AVK_SOFT2:
            if (CheckContents() == SFERR_NO_ERROR) {
                Save();
                TerminateParentFrame();
            }
            break;
    }
    return;
}

// G[nh
XANDLER_IMPLEMENT_VOIDRESULT(DataInputWindow, OnEditHour, invoker, reason, result)
{
    SFZSingleEditBoxControlPtr editbox = static_cast<SFZSingleEditBoxControlPtr>(invoker);
    SInt32 hour = editbox->GetText().AsSInt32();

    unused(reason); unused(result);
    if (hour < 0) {
        hour = 0;
    }
    else if (hour >= 24) {
        hour = 23;
    }
    editbox->SetText(SFXWideString::Format("%d", hour));
    return;
}

// G[nh
XANDLER_IMPLEMENT_VOIDRESULT(DataInputWindow, OnEditMinute, invoker, reason, result)
{
    SFZSingleEditBoxControlPtr editbox = static_cast<SFZSingleEditBoxControlPtr>(invoker);
    SInt32 minute = editbox->GetText().AsSInt32();

    unused(reason); unused(result);
    if (minute < 0) {
        minute = 0;
    }
    else if (minute >= 60) {
        minute = 59;
    }
    editbox->SetText(SFXWideString::Format("%d", minute));
    return;
}
