#ifndef __DATAINPUTWINDOW_HPP
#define __DATAINPUTWINDOW_HPP

#include <SophiaFramework.hpp>
#include "VCalendar.hpp"
#include "Dialoger.hpp"

SFMTYPEDEFRESPONDER(DataInputWindow)
class DataInputWindow : public SFZWindow {
    SFMSEALRESPONDER(DataInputWindow)
    SFMRESPONDERINSTANTIATEFOUR(DataInputWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
private:
    enum PlacementEnum {
        MARGIN_X = 2,
        MARGIN_Y = 2
    };
    SFMTYPEDEFSTRUCT(DateInputRowRec)
    struct DateInputRowRec {
        SFXDate                         date;           // 
        SFZSingleTextLabelControlSmp    labelDate;      // tx
        SFZSingleTextLabelControlSmp    labelHour;      // x
        SFZSingleTextLabelControlSmp    labelMin;       // x
        SFZSingleEditBoxControlSmp      editHour;       // GfBbg{bNX
        SFZSingleEditBoxControlSmp      editMin;        // GfBbg{bNX
    };
    VCalendarItemPtr                _vcal;                  // J_[\Pڕ
    DateInputRowRec                 _start;                 // Jn֘AX|_̏W܂
    DateInputRowRec                 _end;                   // I֘AX|_̏W܂
    SFZSingleTextLabelControlSmp    _labelPlan;             // \胉x
    SFZMultipleEditBoxControlSmp    _editPlan;              // \GfBbg{bNX
    DialogerPtr                     _dialoger;              // _CAOwp[
public:
                                    DataInputWindow(Void) static_throws;
    virtual                         ~DataInputWindow(Void);
    static  DataInputWindowSmp      NewInstance(SFCErrorPtr exception);
            SFCError                Make(SFXDateConstRef date, VCalendarItemPtr vcal);
private:
            SFCError                SetSoftMenu(Void);
            SFCError                CreateStartRow(Void);
            SFCError                CreateEndRow(Void);
            SFCError                CreateRowImpl(DateInputRowRecRef rec, SFXWideStringConstRef text);
            SFCError                CreatePlan(Void);
            SFCError                CheckContents(Void);
            Void                    Locate(Void);
            Void                    Save(Void);
            Void                    TerminateParentFrame(Void);
    XANDLER_DECLARE_BOOLEVENT(OnKey)                        // L[nh
    XANDLER_DECLARE_VOIDEVENT(OnSoftKey)                    // \tgL[nh
    XANDLER_DECLARE_VOIDRESULT(OnEditHour)                  // G[nh
    XANDLER_DECLARE_VOIDRESULT(OnEditMinute)                // G[nh
};

#endif //__DATAINPUTWINDOW_HPP
