#include "Dialoger.hpp"
#include "SoftMenuID.hpp"
#include "syncscheduler_sfy.brh"
#include "syncscheduler_sfy.hpp"
//#include "ColorDef.hpp"

#define TEXT_BUTTON_OK          syncscheduler_sfy::LoadString(IDS_OK)
#define TEXT_BUTTON_CANCEL      syncscheduler_sfy::LoadString(IDS_CANCEL)
#define TEXT_CONFIRM            syncscheduler_sfy::LoadString(IDS_CONFIRM)
#define TEXT_ERROR              syncscheduler_sfy::LoadString(IDS_ERROR)
#define TEXT_CONNECTING         ""
#define TEXT_DONE               ""

Dialoger::Dialoger(Void) :
    _enumTitle(Dialoger::UNUSE),
    _spp(null),
    _reference(null),
    _button(Dialoger::DEFAULT),
    _margin(SFXMargin(10, 10))
{
}

// _CAOʃnh̐ݒ
Void Dialoger::RegisterHandler(SFYHandler::HandlerSPP spp, VoidPtr reference)
{
    _spp = spp;
    _reference = reference;
    return;
}

// OK / Cancel {^̗L̐ݒ
Void Dialoger::SetButtonState(UInt32 param)
{
    _button = param;
    return;
}

// t[^Cg̐ݒ
Void Dialoger::SetTitle(SFXWideStringConstRef param)
{
    _title = param;
    return;
}

// t[^Cg(index)̐ݒ
Void Dialoger::SetTitle(TitleEnum index)
{
    _enumTitle = index;
    return;
}

// _CAObZ[W̐ݒ
Void Dialoger::SetMessageText(SFXWideStringConstRef param)
{
    _message = param;
    return;
}

// ACRC[W̐ݒ
Void Dialoger::SetIconImage(SFBImageSmpConstRef param)
{
    _icon = param;
    return;
}

// }[W̐ݒ
Void Dialoger::SetMargin(SFXMarginConstRef param)
{
    _margin = param;
    return;
}

// t[t_CAO쐬ĕ\
SFCError Dialoger::Execute(Void)
{
    static SFXEventRange::AtomRecConst  range = {
        SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END
    };
    SFZSoftKeyControlSmp soft(syncscheduler_sfy::GetSoftKey());
    SFCError error;

    // _CAÕt[̍쐬
    if ((_frame = SFZTitleFlatFrame::NewInstance(&error)) != null) {
        if ((error = _frame->SetParent(SFYApplication::GetRoot())) == SFERR_NO_ERROR) {
            LoadTitle(_enumTitle);
            if ((error = _frame->SetText(_title)) == SFERR_NO_ERROR) {
                //_frame->SetHeaderColor(COLOR_TITLE_BACK);
                //_frame->SetTextColor(COLOR_TITLE_FORE);
                _frame->SetState(true, true, true, true);
                _frame->ToFront();
            }
        }
    }
    if (error == SFERR_NO_ERROR) {
        // _CAO̍쐬
        if ((_dialog = SFZQuestionDialog::NewInstance(&error)) != null) {
            if ((error = _dialog->SetParent(_frame)) == SFERR_NO_ERROR) {
                if (_spp == null) {
                    _spp = XANDLER_FUNCTION(OnDialogDefault);
                    _reference = this;
                }
                if ((error = _dialog->RegisterHandler(*atomic_cast(&range), _spp, _reference)) == SFERR_NO_ERROR) {
                    if ((error = _dialog->SetIconImage(_icon)) == SFERR_NO_ERROR) {
                        if ((error = _dialog->SetMessageText(_message)) == SFERR_NO_ERROR) {
                            if (!(_button & OK) || (error = _dialog->SetButtonText(SFZQuestionDialog::BUTTON_OK, TEXT_BUTTON_OK)) == SFERR_NO_ERROR) {
                                if (!(_button & CANCEL) || (error = _dialog->SetButtonText(SFZQuestionDialog::BUTTON_CANCEL, TEXT_BUTTON_CANCEL)) == SFERR_NO_ERROR) {
                                    SFXMargin margin(_frame->GetSuitableMargin());
                                    SFXRectangle active(SFXRectangle(SFYApplication::GetRoot()->GetLocalBound()).SetBottom(soft->GetRealBound().GetTop()));
                                    SFXRectangle rectangle(active);
                                    rectangle = _dialog->GetSuitableBound(rectangle.Deflate(_margin).Deflate(margin));
                                    rectangle.Inflate(margin);
                                    rectangle.SnapCenterMiddle(active.GetCenterMiddle());
                                    _frame->SetRealBound(rectangle);
                                    _dialog->SetRealBound(_frame->GetLocalBound().Deflate(margin));
                                    if (!soft->ContainsMenuKey(SOFTMENU_SELECT)) {
                                        if ((error = soft->CreateMenu(SOFTMENU_SELECT)) == SFERR_NO_ERROR) {
                                            UInt32 text_key[] = {IDS_SOFTKEY_SELECT, 0, 0};
                                            Bool enable[] = {true, false, false};
                                            if ((error = soft->SetTextKey(SOFTMENU_SELECT, text_key, lengthof(text_key))) == SFERR_NO_ERROR) {
                                                error = soft->SetEnable(SOFTMENU_SELECT, enable, lengthof(enable));
                                            }
                                        }
                                    }
                                    if (error == SFERR_NO_ERROR) {
                                        if ((error = soft->Bind(_dialog.Get(), SOFTMENU_SELECT)) == SFERR_NO_ERROR) {
                                            _dialog->SetState(true, true, true, true);
                                            _dialog->ToFront();
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return error;
}

// t[ƃ_CAǑn
Void Dialoger::Terminate(Void)
{
    if (_frame != null) {
        _frame->Terminate();
    }
    _button = Dialoger::DEFAULT;
    _reference = null;
    _spp = null;
    _icon.Release();
    _message.Clear();
    _enumTitle = UNUSE;
    _title.Clear();
    _dialog.Release();
    _frame.Release();
    return;
}

// ^Cg index ̓ǂݍ
Void Dialoger::LoadTitle(TitleEnum index)
{
    switch (index) {
        case CONFIRM:
            _title = TEXT_CONFIRM;
            break;
        case ERROR:
            _title = TEXT_ERROR;
            break;
        case CONNECTING:
            _title = TEXT_CONNECTING;
            break;
        case DONE:
            _title = TEXT_DONE;
            break;
        case UNUSE: default:
            break;
    }
    return;
}

// ftHg_CAOnh
XANDLER_IMPLEMENT_VOIDRESULT(Dialoger, OnDialogDefault, invoker, reason, result)
{
    unused(invoker); unused(reason); unused(result);
    Terminate();
    return;
}
