#ifndef __DIALOGER_HPP
#define __DIALOGER_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(Dialoger)
class Dialoger {
    public:
        enum ButtonStateEnum {
            OK = 1 << 0,
            CANCEL = 1 << 1,
            DEFAULT = OK
        };
        SFMTYPEDEFTYPE(ButtonStateEnum)
        enum TitleEnum {
            UNUSE,
            CONFIRM,
            ERROR,
            CONNECTING,
            DONE
        };
        SFMTYPEDEFTYPE(TitleEnum)
    private:
        SFZTitleFlatFrameSmp        _frame;             // _CAÕt[
        SFZQuestionDialogSmp        _dialog;            // ڑmF_CAO
        SFXWideString               _title;             // t[^Cg
        TitleEnum                   _enumTitle;         // t[^Cg(index)
        SFXWideString               _message;           // _CAObZ[W
        SFBImageSmp                 _icon;              // ACRC[W
        SFYHandler::HandlerSPP      _spp;               // nh|C^
        VoidPtr                     _reference;         // nht@Xl
        UInt32                      _button;            // {^(OK | CANCEL)
        SFXMargin                   _margin;            // \tgL[gщʗ̈悩̃}[W
    public:
        explicit Dialoger(Void);
        Void RegisterHandler(SFYHandler::HandlerSPP spp, VoidPtr reference);
        Void SetButtonState(UInt32 param);
        Void SetTitle(SFXWideStringConstRef param);
        Void SetTitle(TitleEnum index);
        Void SetMessageText(SFXWideStringConstRef param);
        Void SetIconImage(SFBImageSmpConstRef param);
        Void SetMargin(SFXMarginConstRef param);
        SFCError Execute(Void);
        Void Terminate(Void);
    private:
        Void LoadTitle(TitleEnum index);
        XANDLER_DECLARE_VOIDRESULT(OnDialogDefault)     // ftHg_CAOnh
};

#endif//__DIALOGER_HPP
