#include "MainWindow.hpp"
#include "syncscheduler_sfy.brh"
#include "syncscheduler_sfy.hpp"
#include "SoftMenuID.hpp"
#include "ColorDef.hpp"

#define COLOR_WEEKEND_TITLE_BACK            COLOR_DODGER_BLUE
#define COLOR_WEEKDAY_TITLE_BACK            COLOR_MINT_GREEN
#define COLOR_WEEKEND_ITEM_BACK             COLOR_PERIWINKLE
#define COLOR_WEEKDAY_ITEM_BACK             COLOR_REEF
#define COLOR_TODAY_ITEM_BACK               COLOR_SUPERNOVA
#define COLOR_SCHEDULED_ITEM_BACK           COLOR_CINNABAR

// RXgN^
MainWindow::MainWindow(Void) static_throws
{
    if (static_try()) {
        // \tgL[nh̓o^
        static_throw(RegisterHandler(
            SFXEventRange(SFEVT_RESPONDER_SOFTKEY, SFEVT_RESPONDER_SOFTKEY, AVK_SOFT1, AVK_SOFT2),
            XANDLER_INTERNAL(OnSoftKey)
        ));
        if (static_try()) {
            // \tgL[j[̐ݒ
            static_throw(SetSoftMenu());
            if (static_try()) {
                // _CAOwp[̎擾
                if ((_dialoger = syncscheduler_sfy::GetDialoger()) != null) {
                    // ݒ̎擾
                    _config = syncscheduler_sfy::GetConfig();
                    // \̎擾
                    _vcalCollection = syncscheduler_sfy::GetVCalCollection();
                    // ݎ̎擾
                    _cursor =  SFXDate::CurrentDate();
                }
                else {
                    static_throw(SFERR_FAILED);
                }
            }
        }
    }
}

// fXgN^
MainWindow::~MainWindow(Void)
{
}

// CX^X̍쐬
MainWindowSmp MainWindow::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<MainWindow>(Factory(::new MainWindow, exception));
}

// X|_̍쐬
SFCError MainWindow::Make(Void)
{
    SFCError error(SFERR_NO_ERROR);

    if ((error = CreateCalMenu()) == SFERR_NO_ERROR) {
        error = RefreshCalMenu();
    }
    return error;
}

// \tgL[j[̐ݒ
SFCError MainWindow::SetSoftMenu(Void)
{
    SFCError error(SFERR_NO_ERROR);

    if ((_softkey = syncscheduler_sfy::GetSoftKey()) != null) {
        if (!_softkey->ContainsMenuKey(SOFTMENU_MAIN)) {
            if ((error = _softkey->CreateMenu(SOFTMENU_MAIN)) == SFERR_NO_ERROR) {
                UInt32 key[] = {IDS_SOFTKEY_SELECT, IDS_SOFTKEY_EXIT, IDS_SOFTKEY_MENU};
                error = _softkey->SetTextKey(SOFTMENU_MAIN, key, lengthof(key));
            }
        }
        if (error == SFERR_NO_ERROR) {
            if (!_softkey->ContainsMenuKey(SOFTMENU_SUBMENU)) {
                if ((error = _softkey->CreateMenu(SOFTMENU_SUBMENU)) == SFERR_NO_ERROR) {
                    UInt32 key[] = {IDS_SOFTKEY_SELECT, IDS_SOFTKEY_CLOSE, 0};
                    if ((error = _softkey->SetTextKey(SOFTMENU_SUBMENU, key, lengthof(key))) == SFERR_NO_ERROR) {
                        error = _softkey->SetEnable(SOFTMENU_SUBMENU, SFZSoftKeyControl::SOFTKEY_2, false);
                    }
                }
            }
        }
        if (error == SFERR_NO_ERROR) {
            error = _softkey->Bind(this, SOFTMENU_MAIN);
        }
    }
    else {
        error = SFERR_FAILED;
    }
    return error;
}

// ^Cgt[̍쐬Ɣzu
SFCError MainWindow::CreateFrame(SFXAnsiStringConstRef title)
{
    SFCError error;

    if ((_frame = SFZTitlePlainFrame::NewInstance(&error)) != null) {
        if ((error = _frame->SetParent(GetRoot())) == SFERR_NO_ERROR) {
            if ((error = _frame->SetText(title)) == SFERR_NO_ERROR) {
                _frame->SetRealBound(syncscheduler_sfy::GetContentRect());
                _frame->SetState(true, true, true, true);
                _frame->ToFront();
            }
        }
        if (error != SFERR_NO_ERROR) {
            _frame->Terminate();
        }
    }
    return error;
}

// J_[j[̍쐬
SFCError MainWindow::CreateCalMenu(Void)
{
    SFCError error;

    if ((_calMenu= SFZGridMenu::NewInstance(&error)) != null) {
        if ((error = _calMenu->SetParent(GetThis())) == SFERR_NO_ERROR) {
            error = _calMenu->RegisterHandler(
                SFXEventRange(SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnKeyMove)
            );
            if (error == SFERR_NO_ERROR) {
                _calMenu->SetTitleForeColor(COLOR_MENU_TITLE_FORE);
                _calMenu->SetTitleBackColor(COLOR_MENU_TITLE_BACK);
                _calMenu->SetBackgroundColor(GetBackgroundColor());
                _calMenu->SetDrawSelBorder(true);
                _calMenu->SetRowCol(7, 7);
                _calMenu->SetPadding(true);
                for (SIntN i = 0; i < 7 * 7; i++) {
                    if ((error = _calMenu->AppendItem("")) != SFERR_NO_ERROR) {
                        break;
                    }
                }
                SInt16 W = GetLocalBound().GetWidth();
                SInt16 H = GetLocalBound().GetHeight();
                SInt16 w = (W - 8) / 7;
                SInt16 h = (H - 8 - _calMenu->GetTitleHeight()) / 7;
                SFXRectangle rc;
                rc.Set(SFXGrid::ZeroInstance(), w * 7 + 8, h * 7 + 8 + _calMenu->GetTitleHeight());
                _calMenu->SetRealBound(rc.SnapCenterMiddle(GetLocalBound().GetCenterMiddle()));
                _calMenu->SetState(true, true, true, true);
            }
        }
    }
    return error;
}

// Tuj[̍쐬Ɣzu
SFCError MainWindow::CreateSubMenu(Void)
{
    static SFXEventRange::AtomRecConst range[] = {
        {SFEVT_RESPONDER_RESULT, SFEVT_RESPONDER_RESULT, SFP16_BEGIN, SFP16_END},
        {SFEVT_RESPONDER_SOFTKEY, SFEVT_RESPONDER_SOFTKEY, AVK_SOFT1, AVK_SOFT1}
    };
    SFYHandler::RuleRec rule[lengthof(range)];
    SFZTextMenuSmp setting;
    SFXRectangle rc(syncscheduler_sfy::GetContentRect());
    SFCError error;

    if ((setting= SFZTextMenu::NewInstance(&error)) != null) {
        if ((error = setting->SetParent(GetRoot())) == SFERR_NO_ERROR) {
            rule[0].spp = XANDLER_FUNCTION(OnSubMenu);         // j[nh
            rule[0].reference = this;
            rule[1].spp = XANDLER_FUNCTION(OnSubMenuSoftKey);  // j[\tgL[nh
            rule[1].reference = this;
            if ((error = setting->RegisterHandler(atomic_cast(range), rule, lengthof(range))) == SFERR_NO_ERROR) {
                if ((error = setting->SetTitle(syncscheduler_sfy::LoadString(IDS_MENU))) == SFERR_NO_ERROR) {
                    setting->SetDefaultItemBackColor(COLOR_MENU_ITEM_EVEN_BACK);
                    setting->SetTitleForeColor(COLOR_MENU_TITLE_FORE);
                    setting->SetTitleBackColor(COLOR_MENU_TITLE_BACK);
                    setting->SetSelBackColor(COLOR_MENU_SEL_BACK);
                    if ((error = setting->AppendItem(syncscheduler_sfy::LoadString(IDS_SETTING))) == SFERR_NO_ERROR) {
                        if ((error = setting->AppendItem(syncscheduler_sfy::LoadString(IDS_VERSION_INFO))) == SFERR_NO_ERROR) {
                            rc.SetTop(rc.GetBottom() - (setting->GetTitleHeight() + setting->GetItemHeight() * (SInt16)setting->GetItemCount()));
                            rc.SetLeft(rc.GetRight() - rc.GetWidth() / 3 * 2);
                            setting->SetRealBound(rc);
                            setting->SetState(true, true, true, true);
                            setting->ToFront();
                            error = _softkey->Bind(setting.Get(), SOFTMENU_SUBMENU);
                        }
                    }
                }
            }
        }
    }
    return error;
}

// ̗\EBhE̍쐬Ɣzu
SFCError MainWindow::CreateOneDayWindow(Void)
{
    OneDayWindowSmp oneday;
    SFCError error;

    if ((oneday = OneDayWindow::NewInstance(&error)) != null) {
        if ((error = oneday->SetParent(_frame)) == SFERR_NO_ERROR) {
            oneday->SetRealBound(_frame->GetLocalBound().Deflate(_frame->GetSuitableMargin()));
            oneday->SetState(true, true, true, true);
            error = oneday->Make(_cursor);
        }
    }
    return error;
}

// ݒEBhE̍쐬Ɣzu
SFCError MainWindow::CreateSetupWindow(Void)
{
    SetupWindowSmp setup;
    SFCError error;

    if ((setup = SetupWindow::NewInstance(&error)) != null) {
        if ((error = setup->SetParent(_frame)) == SFERR_NO_ERROR) {
            error = setup->RegisterHandler(
                SFXEventRange(SFEVT_RESPONDER_STATE, SFEVT_RESPONDER_STATE, SFP16_BEGIN, SFP16_END),
                XANDLER_INTERNAL(OnSetupWindowValid)
            );
            if (error == SFERR_NO_ERROR) {
                setup->SetRealBound(_frame->GetLocalBound().Deflate(_frame->GetSuitableMargin()));
                setup->SetState(true, true, true, true);
                error = setup->Make();
            }
        }
    }
    return error;
}

// J_[j[XV
SFCError MainWindow::RefreshCalMenu(Void)
{
    SInt16 year     = _cursor.GetYear();
    SInt16 month    = _cursor.GetMonth();
    SInt16 i, j;
    SFCError error;

    if ((error = _calMenu->SetTitle(GetDateName(_cursor))) == SFERR_NO_ERROR) {
        _calMenu->SetSelBackColor(COLOR_MENU_SEL_BACK);
        _calMenu->SetSelForeColor(COLOR_MENU_SEL_FORE);
        for (i = 0; i < 7 * 7; ++i) {
            if ((error = _calMenu->SetItemText(i, "")) == SFERR_NO_ERROR) {
                _calMenu->SetItemBackColor(i, COLOR_WHITE);
            }
            if (error != SFERR_NO_ERROR) {
                return error;
            }
        }
        // 1 s: j
        SFXWideString week = syncscheduler_sfy::LoadString(IDS_WEEK);
        for (i = 0 ; i < 7 ; i++) {
            error = _calMenu->SetItemText(i, SFXWideString(week.GetChar(i)));
            switch (i) {
                case 0:
                case 6:
                    _calMenu->SetItemBackColor(i, COLOR_WEEKEND_TITLE_BACK);    // yjAj̐Fݒ肷
                    break;
                default:
                    _calMenu->SetItemBackColor(i, COLOR_WEEKDAY_TITLE_BACK);    // ̐Fݒ肷
                    break;
            }
        }
        SFXDate sDate(year, month, 1);      // 
        SFXDate eDate(year, month + 1, 0);  // 
        // 2 s: uN
        j = 0;
        if (sDate.GetDayOfWeek() != SFXDate::DAYOFWEEK_SUNDAY) {
            j += sDate.GetDayOfWeek() + 1;
            i += sDate.GetDayOfWeek() + 1;
        }
        SFXDate currentDay = SFXDate::CurrentDate();
        currentDay.SetTime(0, 0, 0);
        // ts
        for (SFXDate iDate = sDate; iDate <= eDate; iDate.AddDay(1), i++) {
            _calMenu->SetItemText(i, SFXAnsiString::Format("%2d", iDate.GetDay()));
            switch (iDate.GetDayOfWeek()) {
                case SFXDate::DAYOFWEEK_SATURDAY:
                case SFXDate::DAYOFWEEK_SUNDAY:
                    _calMenu->SetItemBackColor(i, COLOR_WEEKEND_ITEM_BACK);
                    break;
                default:
                    _calMenu->SetItemBackColor(i, COLOR_WEEKDAY_ITEM_BACK);
                    break;
            }
            if (_vcalCollection->IsDataExist(year, month, iDate.GetDay())) {
                _calMenu->SetItemBackColor(i, COLOR_SCHEDULED_ITEM_BACK);
            }
            if (iDate == currentDay) {
                _calMenu->SetItemBackColor(i, COLOR_TODAY_ITEM_BACK);
            }
        }
        _calMenu->SetSelect(7 + j + _cursor.GetDay() - 1);
    }
    return error;
}

// 擾
SFXAnsiString MainWindow::GetMonthName(SInt16 month)
{
    static ACharConst monthName[12][4] = {
        "Dec", "Jan", "Feb", "Mar", "Apr", "May",
        "Jun", "Jul", "Aug", "Sep", "Oct", "Nov"
    };
    return SFXAnsiString(monthName[month % 12]);
}

// SInt16 -> ɕϊĎ擾
SFXAnsiString MainWindow::GetOrdinalName(SInt16 day)
{
    SFXAnsiString result;

    // 
    switch (day) {
        case 1:
        case 21:
        case 31:
            result = SFXAnsiString::Format("%dst", day);
            break;
        case 2:
        case 22:
            result = SFXAnsiString::Format("%dnd", day);
            break;
        case 3:
        case 23:
            result = SFXAnsiString::Format("%drd", day);
            break;
        default:
            result = SFXAnsiString::Format("%dth", day);
            break;
    }
    return result;
}

// t擾
SFXAnsiString MainWindow::GetDateName(SFXDateConstRef date)
{
    Bool isLong = _config->ReadLongDate();
    Bool isMdy = _config->ReadMdy();
    SFXAnsiString monthlong(GetMonthName(date.GetMonth()));
    SFXAnsiString daylong(GetOrdinalName(date.GetDay()));
    SFXAnsiString result;

    switch ((isMdy ? 1 : 0) << 1 | (isLong ? 1 : 0)) {
        case YMD_SHORT:
            result = SFXAnsiString::Format(
                "%2d, %s %s",
                date.GetYear(), monthlong.GetCString(), daylong.GetCString()
            );
            break;
        case YMD_LONG:
            result = SFXAnsiString::Format(
                syncscheduler_sfy::LoadString(IDS_DATE_FORMAT_SETTING_YMD),
                date.GetYear(), date.GetMonth(), date.GetDay()
            );
            break;
        case MDY_SHORT:
            result = SFXAnsiString::Format(
                "%s %s, %2d",
                monthlong.GetCString(), daylong.GetCString(), date.GetYear()
            );
            break;
        case MDY_LONG:
            result = SFXAnsiString::Format(
                syncscheduler_sfy::LoadString(IDS_DATE_FORMAT_SETTING_MDY),
                date.GetMonth(), date.GetDay(), date.GetYear()
            );
            break;
    }
    return result;
}

// L[nhiEBhEOʂɂƂɃL[Ǝsj
XANDLER_IMPLEMENT_BOOLEVENT(MainWindow, OnKeyMove, invoker, event)
{
    Bool result(false);
    SFCError error(SFERR_NO_ERROR);

    unused(invoker);
    switch (event.GetP16()) {
        case AVK_SELECT:
            if ((error = CreateFrame(GetDateName(_cursor))) == SFERR_NO_ERROR) {
                if ((error = CreateOneDayWindow()) != SFERR_NO_ERROR) {
                    _frame->Terminate();
                }
            }
            result = true;
            break;
        case AVK_LEFT:
            _cursor.SubDay(1);      // J[\Ɉړ(1)
            RefreshCalMenu();
            result = true;
            break;
        case AVK_RIGHT:
            _cursor.AddDay(1);      // J[\EɈړ(1)
            RefreshCalMenu();
            result = true;
            break;
        case AVK_UP:
            _cursor.SubDay(7);      // J[\Ɉړ(1TԈ)
            RefreshCalMenu();
            result = true;
            break;
        case AVK_DOWN:
            _cursor.AddDay(7);      // J[\Ɉړ(1Tԉ)
            RefreshCalMenu();
            result = true;
            break;
        case AVK_CLR:
            result = true;
            break;
    }
    return result;
}

// \tgL[nh
XANDLER_IMPLEMENT_VOIDEVENT(MainWindow, OnSoftKey, invoker, event)
{
    SFCError error;

    unused(invoker);
    switch (event.GetP16()) {
        case AVK_SOFT1:
            // ImF_CAO̍쐬
            _dialoger->SetTitle(Dialoger::CONFIRM);
            _dialoger->SetMessageText(syncscheduler_sfy::LoadString(IDS_EXIT_CONFIRM));
            _dialoger->SetButtonState(Dialoger::OK | Dialoger::CANCEL);
            _dialoger->SetIconImage(SFBShell::GetInstance()->LoadResImage(SYNCSCHEDULER_SFY_RES_FILE, IDI_ACCEPT));
            _dialoger->RegisterHandler(XANDLER_INTERNAL(OnTerminate));
            error = _dialoger->Execute();
            break;
        case AVK_SOFT2:
            // Tuj[̍쐬Ɣzu
            error = CreateSubMenu();
            break;
    }
    return;
}

// Tuj[̃nh
XANDLER_IMPLEMENT_VOIDRESULT(MainWindow, OnSubMenu, invoker, reason, result)
{
    unused(invoker);
    SFCError error;

    if (reason == SFP16_RESULT_OK) {
        switch (result) {
        case ITEM_SETTING:  // ݒEBhE쐬
            if ((error = CreateFrame(syncscheduler_sfy::LoadString(IDS_SETTING))) == SFERR_NO_ERROR) {
                if ((error = CreateSetupWindow()) != SFERR_NO_ERROR) {
                    _frame->Terminate();
                }
            }
            break;
        case ITEM_VERSION:  // o[W_CAO쐬
            SFXAnsiString message = syncscheduler_sfy::LoadString(IDS_APPNAME);
            message += "\n" + syncscheduler_sfy::LoadString(IDS_VERSION_DETAIL_2);
            message += "\n" + syncscheduler_sfy::LoadString(IDS_VERSION_DETAIL_3);
            message += "\n" + syncscheduler_sfy::LoadString(IDS_VERSION_DETAIL_4);
            _dialoger->SetTitle(syncscheduler_sfy::LoadString(IDS_VERSION_INFO));
            _dialoger->SetMessageText(message);
            _dialoger->SetIconImage(SFBShell::GetInstance()->LoadResImage(
                SYNCSCHEDULER_SFY_RES_FILE, IDI_VERSION
            ));
            _dialoger->SetButtonState(Dialoger::OK);
            error = _dialoger->Execute();
            break;
        }
    }
    invoker->Terminate();
    return;
}

// Tuj[̃\tgL[nh
XANDLER_IMPLEMENT_VOIDRESULT(MainWindow, OnSubMenuSoftKey, invoker, reason, result)
{
    unused(result);
    switch (reason) {
        case AVK_SOFT1:
            invoker->Terminate();
            break;
    }
    return;
}

// ImF_CAO nh
XANDLER_IMPLEMENT_VOIDRESULT(MainWindow, OnTerminate, invoker, reason, result)
{
    unused (invoker); unused (result);
    switch (reason) {
        case SFP16_RESULT_OK:
            SFYApplication::Terminate();
            break;
        case SFP16_RESULT_ESCAPE:
        case SFP16_RESULT_CANCEL:
            _dialoger->Terminate();
            break;
    }
    return;
}

// ݒEBhELԃnh
XANDLER_IMPLEMENT_VOIDSTATE(MainWindow, OnSetupWindowValid, invoker, reason, state)
{
    unused(invoker); unused(reason);
    if (!state) {
        RefreshCalMenu();
    }
    return;
}
