//
//      MainWindow.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 5.0.
//

#ifndef __MAINWINDOW_HPP
#define __MAINWINDOW_HPP

#include <SophiaFramework.hpp>
#include "OneDayWindow.hpp"
#include "SetupWindow.hpp"
#include "VCalendar.hpp"
#include "SchedulerConfig.hpp"
#include "Dialoger.hpp"

SFMTYPEDEFRESPONDER(MainWindow)
class MainWindow : public SFZWindow {
    SFMSEALRESPONDER(MainWindow)
    SFMRESPONDERINSTANTIATEFOUR(MainWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
private:
    enum SubMenuEnum {
        ITEM_SETTING = 0,
        ITEM_VERSION,
        ITEM_COUNT
    };
    enum DateStyleEnum {
        YMD_SHORT = 0,
        YMD_LONG,
        MDY_SHORT,
        MDY_LONG
    };
    SFMTYPEDEFTYPE(DateStyleEnum)
private:
    SchedulerConfigPtr              _config;                // ݒ
    VCalendarCollectionPtr          _vcalCollection;        // \
    SFXDate                         _cursor;                // J[\ʒu̓t
    SFZGridMenuSmp                  _calMenu;               // J_[Obhj[
    SFZTitlePlainFrameSmp           _frame;                 // t[
    SFZSoftKeyControlSmp            _softkey;               // \tgL[Rg[
    DialogerPtr                     _dialoger;              // _CAOwp[
public:
    explicit                        MainWindow(Void) static_throws;
    virtual                         ~MainWindow(Void);
    static  MainWindowSmp           NewInstance(SFCErrorPtr exception = null);
            SFCError                Make(Void);
private:
            SFCError                SetSoftMenu(Void);
            SFCError                CreateFrame(SFXAnsiStringConstRef title);
            SFCError                CreateCalMenu(Void);
            SFCError                CreateSubMenu(Void);
            SFCError                CreateOneDayWindow(Void);
            SFCError                CreateSetupWindow(Void);
            SFCError                RefreshCalMenu(Void);
            SFXAnsiString           GetMonthName(SInt16 month);
            SFXAnsiString           GetOrdinalName(SInt16 day);
            SFXAnsiString           GetDateName(SFXDateConstRef date);
    XANDLER_DECLARE_BOOLEVENT(OnKeyMove)                    // L[nh
    XANDLER_DECLARE_VOIDEVENT(OnSoftKey)                    // \tgL[nh
    XANDLER_DECLARE_VOIDRESULT(OnSubMenu)                   // Tuj[̃nh
    XANDLER_DECLARE_VOIDRESULT(OnSubMenuSoftKey)            // Tuj[̃\tgL[nh
    XANDLER_DECLARE_VOIDRESULT(OnTerminate)                 // ImF_CAOnh
    XANDLER_DECLARE_VOIDSTATE(OnSetupWindowValid)           // ݒEBhELԃnh
};

#endif // __MAINWINDOW_HPP
