#ifndef __ONEDAYWINDOW_HPP
#define __ONEDAYWINDOW_HPP

#include <SophiaFramework.hpp>
#include "DataInputWindow.hpp"
#include "VCalendar.hpp"
#include "Dialoger.hpp"

SFMTYPEDEFRESPONDER(OneDayWindow)
class OneDayWindow : public SFZWindow {
    SFMSEALRESPONDER(OneDayWindow)
    SFMRESPONDERINSTANTIATEFOUR(OneDayWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)

public:
    SFMTYPEDEFTYPE(CodeEnum)
private:
    enum SubMenuEnum {
        ITEM_NEW = 0,
        ITEM_DELETE,
        ITEM_COUNT
    };
private:
    SFXDate                         _cursor;                // ݃J[\̓t
    SInt32                          _todayIndex;            // ݃J[\t̃CfbNX
    SInt32                          _todaySize;             // ݃J[\t̗\̐
    VCalendarCollectionPtr          _vcalCollection;        // \
    SFZTextMenuSmp                  _menu;                  // ̗\胁j[
    SFZTitlePlainFrameSmp           _frame;                 // t[
    SFZSoftKeyControlSmp            _softkey;               // \tgL[Rg[
    DialogerPtr                     _dialoger;              // _CAOwp[
public:
                                    OneDayWindow(Void) static_throws;
    virtual                         ~OneDayWindow(Void);
    static  OneDayWindowSmp         NewInstance(SFCErrorPtr exception);
            SFCError                Make(SFXDateConstRef date);
private:
            SFCError                SetSoftMenu(Void);
            SFCError                CreateFrame(SFXAnsiStringConstRef title);
            SFCError                CreateScheduleMenu(Void);
            SFCError                RefreshMenu(Void);
            SFCError                CreateDataInputWindow(VCalendarItemPtr vcal);
            SFCError                CreateSubMenu(Void);
            SFXWideStringConstRef   GetParentFrameTitle(Void);
            Void                    TerminateParentFrame(Void);
    XANDLER_DECLARE_VOIDRESULT(OnMenu)                      // j[nh
    XANDLER_DECLARE_VOIDEVENT(OnSoftKey)                    // \tgL[nh
    XANDLER_DECLARE_VOIDRESULT(OnDelete)                    // 폜nh
    XANDLER_DECLARE_VOIDSTATE(OnDataInputWindowValid)       // f[^̓EBhELԃnh
    XANDLER_DECLARE_VOIDRESULT(OnSubMenu)                   // Tuj[̃nh
    XANDLER_DECLARE_VOIDRESULT(OnSubMenuSoftKey)            // Tuj[̃\tgL[nh
};

#endif //__ONEDAYWINDOW_HPP
