#include "SetupWindow.hpp"
#include "syncscheduler_sfy.hpp"
#include "MainWindow.hpp"
#include "syncscheduler_sfy.brh"
#include "SoftMenuID.hpp"

// RXgN^
SetupWindow::SetupWindow(Void) static_throws
{
    static SFXEventRange::AtomRecConst range[] = {
        {SFEVT_KEY, SFEVT_KEY, SFP16_BEGIN, SFP16_END},
        {SFEVT_RESPONDER_SOFTKEY, SFEVT_RESPONDER_SOFTKEY, AVK_SOFT1, AVK_SOFT2}
    };
    SFYHandler::RuleRec rule[lengthof(range)];

    if (static_try()) {
        rule[0].spp = XANDLER_FUNCTION(OnKey);
        rule[0].reference = this;
        rule[1].spp = XANDLER_FUNCTION(OnSoftKey);
        rule[1].reference = this;
        // nh̓o^
        static_throw(RegisterHandler(atomic_cast(range), rule, lengthof(range)));
        if (static_try()) {
            // \tgL[j[̐ݒ
            static_throw(SetSoftMenu());
            if (static_try()) {
                // ݒ̓ǂݍ
                _config = syncscheduler_sfy::GetConfig();
            }
        }
    }
}

// fXgN^
SetupWindow::~SetupWindow(Void)
{
}

// CX^X̍쐬
SetupWindowSmp SetupWindow::NewInstance(SFCErrorPtr exception)
{
    return static_pointer_cast<SetupWindow>(Factory(::new SetupWindow, exception));
}

// X|_̍쐬
SFCError SetupWindow::Make(Void)
{
    SFCError error;

    if ((error = CreateDateFormat()) == SFERR_NO_ERROR) {
        if ((error = CreateDateStyle()) == SFERR_NO_ERROR) {
            Locate();
        }
    }
    return error;
}

// \tgL[j[̐ݒ
SFCError SetupWindow::SetSoftMenu(Void)
{
    SFZSoftKeyControlSmp softkey;
    SFCError error(SFERR_NO_ERROR);

    if ((softkey = syncscheduler_sfy::GetSoftKey()) != null) {
        if (!softkey->ContainsMenuKey(SOFTMENU_SETUP)) {
            if ((error = softkey->CreateMenu(SOFTMENU_SETUP)) == SFERR_NO_ERROR) {
                UInt32 key[] = {IDS_SOFTKEY_SELECT, IDS_SOFTKEY_RETURN, IDS_SOFTKEY_SAVE};
                error = softkey->SetTextKey(SOFTMENU_SETUP, key, lengthof(key));
            }
        }
        if (error == SFERR_NO_ERROR) {
            softkey->Bind(this, SOFTMENU_SETUP);
        }
    }
    else {
        error = SFERR_FAILED;
    }
    return error;
}

// ݒۑ
SFCError SetupWindow::Save(Void)
{
    SFCError error;

    error = _config->WriteLongDate(static_cast<Bool>(_radioLongdate->GetCurrentValue()));
    if (error == SFERR_NO_ERROR) {
        error = _config->WriteMdy(static_cast<Bool>(_radioMDY->GetCurrentValue()));
        if (error == SFERR_NO_ERROR) {
            error = _config->Save();
        }
    }
    return error;
}

// ttH[}bg֘AX|_̍쐬
SFCError SetupWindow::CreateDateFormat(Void)
{
    SFCError error;

    // ttH[}bg x̍쐬
    if ((_labelDateFormat = SFZSingleTextLabelControl::NewInstance(&error)) != null) {
        if ((error = _labelDateFormat->SetParent(GetThis())) == SFERR_NO_ERROR) {
            error = _labelDateFormat->SetText(syncscheduler_sfy::LoadString(IDS_DATE_FORMAT));
            if (error == SFERR_NO_ERROR) {
                _labelDateFormat->SetHorizontalAlign(SFZSingleTextLabelControl::HORIZONTAL_LEFT);
                _labelDateFormat->SetState(true, true, false, false);
            }
        }
    }
    // m[}t\ WI{^̍쐬
    if (error == SFERR_NO_ERROR) {
        if ((_radioNormaldate = SFZRadiobuttonControl::NewInstance(&error)) != null) {
            if ((error = _radioNormaldate->SetParent(GetThis())) == SFERR_NO_ERROR) {
                error = _radioNormaldate->SetText(syncscheduler_sfy::LoadString(IDS_DATE_NORMAL));
                if (error == SFERR_NO_ERROR) {
                    _radioNormaldate->SetHorizontalAlign(SFZRadiobuttonControl::HORIZONTAL_LEFT);
                    _radioNormaldate->SetCurrentValue(!_config->ReadLongDate());
                    _radioNormaldate->SetState(true, true, true, false);
                }
            }
        }
    }
    // Ot\ WI{^̍쐬
    if (error == SFERR_NO_ERROR) {
        if ((_radioLongdate = SFZRadiobuttonControl::NewInstance(&error)) != null) {
            if ((error = _radioLongdate->SetParent(GetThis())) == SFERR_NO_ERROR) {
                error = _radioLongdate->SetText(syncscheduler_sfy::LoadString(IDS_DATE_LONG));
                if (error == SFERR_NO_ERROR) {
                    _radioLongdate->SetHorizontalAlign(SFZRadiobuttonControl::HORIZONTAL_LEFT);
                    _radioLongdate->SetCurrentValue(_config->ReadLongDate());
                    _radioLongdate->SetState(true, true, true, false);
                }
            }
        }
    }
    // WI{^̃O[v
    if (error == SFERR_NO_ERROR) {
        _radioLongdate->Group(_radioNormaldate);
    }
    return error;
}

// tX^C֘AX|_̍쐬
SFCError SetupWindow::CreateDateStyle(Void)
{
    SFCError error;

    // tX^C x̍쐬
    if ((_labelDateStyle = SFZSingleTextLabelControl::NewInstance(&error)) != null) {
        if ((error = _labelDateStyle->SetParent(GetThis())) == SFERR_NO_ERROR) {
            error = _labelDateStyle->SetText(syncscheduler_sfy::LoadString(IDS_DATE_STYLE));
            if (error == SFERR_NO_ERROR) {
                _labelDateStyle->SetHorizontalAlign(SFZSingleTextLabelControl::HORIZONTAL_LEFT);
                _labelDateStyle->SetState(true, true, false, false);
            }
        }
    }
    //uN--v(YMD) X^C WI{^̍쐬
    if (error == SFERR_NO_ERROR) {
        if ((_radioYMD = SFZRadiobuttonControl::NewInstance(&error)) != null) {
            if ((error = _radioYMD->SetParent(GetThis())) == SFERR_NO_ERROR) {
                error = _radioYMD->SetText(syncscheduler_sfy::LoadString(IDS_DATE_STYLE_YMD));
                if (error == SFERR_NO_ERROR) {
                    _radioYMD->SetHorizontalAlign(SFZRadiobuttonControl::HORIZONTAL_LEFT);
                    _radioYMD->SetCurrentValue(!_config->ReadMdy());
                    _radioYMD->SetState(true, true, true, false);
                }
            }
        }
    }
    //u--Nv(MDY) \ WI{^̍쐬
    if (error == SFERR_NO_ERROR) {
        if ((_radioMDY = SFZRadiobuttonControl::NewInstance(&error)) != null) {
            if ((error = _radioMDY->SetParent(GetThis())) == SFERR_NO_ERROR) {
                error = _radioMDY->SetText(syncscheduler_sfy::LoadString(IDS_DATE_STYLE_MDY));
                if (error == SFERR_NO_ERROR) {
                    _radioMDY->SetHorizontalAlign(SFZRadiobuttonControl::HORIZONTAL_LEFT);
                    _radioMDY->SetCurrentValue(_config->ReadMdy());
                    _radioMDY->SetState(true, true, true, false);
                }
            }
        }
    }
    // WI{^̃O[v
    if (error == SFERR_NO_ERROR) {
        _radioMDY->Group(_radioYMD);
    }
    return error;
}

// X|_̔zu
Void SetupWindow::Locate(Void)
{
    SFXRectangle temp;
    SInt16  W, H, w, h, x, y;

    x = MARGIN_X;
    y = MARGIN_Y;
    temp = SFXRectangle(SFXGrid::ZeroInstance(), GetRealBound().GetSize());
    W = temp.GetWidth() - 2 * MARGIN_X;
    H = temp.GetHeight() - 2 * MARGIN_Y;
    w = W;
    h = H / 9;
    y += h;
    _labelDateFormat->SetRealBound(SFXRectangle(x, y, w, h));
    y += h;
    _radioNormaldate->SetRealBound(SFXRectangle(x, y, w, h));
    y += h;
    _radioLongdate->SetRealBound(SFXRectangle(x, y, w, h));
    y += 2 * h;
    _labelDateStyle->SetRealBound(SFXRectangle(x, y, w, h));
    y += h;
    _radioYMD->SetRealBound(SFXRectangle(x, y, w, h));
    y += h;
    _radioMDY->SetRealBound(SFXRectangle(x, y, w, h));
    //y += 2 * h;
    return;
}

// ẽt[ƃEBhEI
Void SetupWindow::TerminateParentFrame(Void)
{
    SFYResponderSmp parent(GetParent());

    if (parent != null) {
        parent->Terminate();
    }
    return;
}

// L[nh
XANDLER_IMPLEMENT_BOOLEVENT(SetupWindow, OnKey, invoker, event)
{
    Bool result(false);

    unused(invoker);
    switch (event.GetP16()) {
        case AVK_CLR:
            TerminateParentFrame();
            result = true;
            break;
    }
    return result;
}

// \tgL[nh
XANDLER_IMPLEMENT_VOIDEVENT(SetupWindow, OnSoftKey, invoker, event)
{
    SFCError error(SFERR_NO_ERROR);

    unused(invoker);
    switch (event.GetP16()) {
        case AVK_SOFT1:
            TerminateParentFrame();
            break;
        case AVK_SOFT2:
            error = Save();
            TerminateParentFrame();
            break;
    }
    return;
}

// ImFnh
XANDLER_IMPLEMENT_VOIDRESULT(SetupWindow, OnTerminate, invoker, reason, result)
{
    unused (invoker); unused (result);
    switch (reason) {
    case SFP16_RESULT_OK:
        SFYApplication::Terminate();
        break;
    case SFP16_RESULT_ESCAPE:
    case SFP16_RESULT_CANCEL:
        _frame->Terminate();
        break;
    }
    return;
}
