#ifndef __SETUPFRAME_HPP
#define __SETUPFRAME_HPP

#include <SophiaFramework.hpp>
#include "SchedulerConfig.hpp"

SFMTYPEDEFRESPONDER(SetupWindow)
class SetupWindow : public SFZWindow {
    SFMSEALRESPONDER(SetupWindow)
    SFMRESPONDERINSTANTIATEFOUR(SetupWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
private:
    enum PlacementEnum {
        MARGIN_X = 2,
        MARGIN_Y = 0
    };
private:
    SchedulerConfigPtr              _config;                // ݒ
    SFZSingleTextLabelControlSmp    _labelDateFormat;       // ttH[}bg x
    SFZSingleTextLabelControlSmp    _labelDateStyle;        // tX^C x
    SFZRadiobuttonControlSmp        _radioNormaldate;       // m[}t\ WI{^
    SFZRadiobuttonControlSmp        _radioLongdate;         // Ot\ WI{^
    SFZRadiobuttonControlSmp        _radioYMD;              // YMD t\ WI{^
    SFZRadiobuttonControlSmp        _radioMDY;              // MDY t\ WI{^
    SFZTitlePlainFrameSmp           _frame;                 // t[
public:
                                    SetupWindow(Void);
    virtual                         ~SetupWindow(Void);
    static  SetupWindowSmp          NewInstance(SFCErrorPtr exception = null);
            SFCError                Make(Void);
private:
            SFCError                SetSoftMenu(Void);
            SFCError                Save(Void);
            SFCError                CreateDateFormat(Void);
            SFCError                CreateDateStyle(Void);
            Void                    Locate(Void);
            Void                    TerminateParentFrame(Void);
    XANDLER_DECLARE_BOOLEVENT(OnKey)                        // L[nh
    XANDLER_DECLARE_VOIDEVENT(OnSoftKey)                    // \tgL[nh
    XANDLER_DECLARE_VOIDRESULT(OnTerminate)                 // ImFnh
};

#endif //__SETUPFRAME_HPP
