#ifndef __VCALENDAR_HPP
#define __VCALENDAR_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(VCalendarItem)
class VCalendarItem {
private:
    SFXDate                     _startDate;             // Jnt
    SFXDate                     _endDate;               // It
    SFXDate                     _lastModifiedDate;      // ŏICt
    SFXAnsiString               _summary;               // v
    SFXAnsiString               _others;                // ̑
public:
                                VCalendarItem(Void);
                                VCalendarItem(SFXAnsiStringConstRef string);
    Void                        SetStartDate(SFXDateConstRef start);
    SFXDate                     GetStartDate(Void) const;
    Void                        SetEndDate(SFXDateConstRef end);
    SFXDate                     GetEndDate(Void) const;
    Void                        SetLastModifiedDate(SFXDateConstRef modified);
    SFXDate                     GetLastModifiedDate(Void) const;
    Void                        SetSummary(SFXAnsiStringConstRef summary);
    SFXAnsiStringConstRef       GetSummary(Void) const;
    Void                        SetOthers(SFXAnsiStringConstRef others);
    SFXAnsiStringConstRef       GetOthers(Void) const;
    Void                        Clear(Void);
    SFCError                    Import(SFXAnsiStringConstRef string);
    SFXAnsiString               Export(Void) const;
    static SFXAnsiString        PublishXid(SFXDateConstRef currentDT);
};

SFMTYPEDEFCLASS(VCalendarCollection)
class VCalendarCollection {
private:
    SFXList<VCalendarItemPtr>   _list;                  // \荀ڂ̃Xg
public:
                                VCalendarCollection(Void);
                                ~VCalendarCollection(Void);
    SFCError                    Save(Void) const;
    SFCError                    Load(Void);
    Void                        Clear(Void);
    SFCError                    InsertLast(VCalendarItemPtr vcal);
    SFCError                    Update(VCalendarItemPtr vcal);
    Void                        Remove(VCalendarItemPtr vcal);
    VCalendarItemPtr            Get(SInt32 index) const;
    SInt32                      GetIndex(SInt16 year, SInt16 month, SInt16 day) const;
    SInt32                      GetNumberOfVCal(SInt32 index, SInt16 year, SInt16 month, SInt16 day) const;
    SInt32                      GetNumberOfVCal(SInt16 year, SInt16 month, SInt16 day) const;
    Bool                        IsDataExist(SInt16 year, SInt16 month, SInt16 day) const;
};

#include "VCalendar.i.hpp"

#endif // __VCALENDAR_HPP //
